//run this as an EA
#include <GoertzelAlgorithm.mqh>

extern int period= 55;
int phase;
int counter=0;
datetime barOpenTime;
double results[];

int init() 
{
   Print("scanner started");
   if(ArrayRange(results,0)!=360) ArrayResize(results,360);
   for (int i=0; i <= 359; i++)
   {
      results[i] = 0;
   }   
   counter=0;
   return(0);
}

int deinit()
{
   writeData();
   return(0);
}

int start()
{
   int i,j,k,r;
   if(newBar())
   {
      //Buffer(0, goertzel);(1, goertzelUa);(2, goertzelUb);(3, goertzelFuture);(4, values);(5, trend);(6, periods);
      phase = getGoertzel(period,_phase,0);
      phase = MathFloor(phase);
      results[phase]++;
      counter++;
   }
   return(0);
}
//+------------------------------------------------------------------+

bool newBar() {
   if (barOpenTime != Time[0]) {
      barOpenTime = Time[0];
      return (TRUE);
   }
   return (FALSE);
}

void writeData()
{
   int handle;
   handle=FileOpen("gorPhaseStudy"+DoubleToStr(period,0)+".csv", FILE_CSV|FILE_WRITE, ',');
   if(handle>0)
   {
      FileWrite(handle, counter+" bars in study");
      for (int i=0; i<=359; i++)
      {
         FileWrite(handle, i, results[i]);
      }
      FileClose(handle);
   }
   Print("FileWrite complete");
}

